<?php
/*
 * JavaHS.php
 *  2008 by Jeffri H
 */

require("show.php");

if (`whoami` != "root\n")
{
  $error = new showNotify("Error", "Not run as root. Exit...", 1, 5);
  $error->exec();
  exit(1);
}

function read_java($java_reg)
{
  $n = 0;
  if ($opn = fopen($java_reg, "r"))
  {
    echo "Reading $java_reg...\n";
    while (! feof($opn))
    {
      $getl = fgets($opn);
      if (ereg("^\[.+\]", $getl))
      {
        if (isset($ret[$n]))
        {
          if ($ret[$n]['JavaId'] == -1)
            unset($ret[$n]);
          else
            $n++;
          continue;
        }
        $n++;
        continue;
      }
      if (ereg("^([A-Za-z]+) *= *(.+)\n$", $getl, $id))
      {
        $ret[$n][$id[1]] = $id[2];
        continue;
      }
    }
    return $ret;
  }
  else
  {
    echo "Open $java_reg failed.\n";
    return false;
  }
}

function read_reg($file)
{
  if ($opn = fopen($file, "r"))
  {
    while (! feof($opn))
    {
      $getl = fgets($opn);
      if (ereg("^Mot-JavaVM-Heapsize *: *([0-9]+)", $getl, $h))
        $ret['heap'] = $h[1];
      elseif (ereg("^Domain *: *(.+)\n$", $getl, $g))
        $ret['domain'] = $g[1];
    }
    return $ret;
  }
  else
  {
    return false;
  }
}

$cancel = 0;
$read = 1;
$java_main = new showList("Java Heap Size", null, null, null, "Exit", null);
$text = new showEntry("Input Number", "Input the heap size you want:");
$properties = new showQ("Properties", null, 2, null, "Back");
$about = new showQ("About", null, 2, null, "Back");
$success = new showNotify("Success", null, 1, 3);
$error = new showNotify("Error", null, 1, 3);
exec("setconfig '/ezx_user/download/appwrite/setup/ezx_system.cfg' 'JavaHeapSize' '0'");

// Start here!
while ($cancel == 0)
{
  if ($read == 1)
  {
    $tmp = read_java("/mmc/mmca1/.system/java/CardRegistry");
    $str = "SD";
    $chg = "Phone";
  }
  else
  {
    $tmp = read_java("/ezx_user/download/appwrite/am/InstalledDB");
    $str = "Phone";
    $chg = "SD";
  }
  if ($tmp == false)
  {
    $error->set_context("Read registry failed.");
    $error->exec();
    exit(1);
  }
  else
  {
    if (isset($list)) unset($list);
    for ($x = 1; $x <= count($tmp); $x++)
    {
      $list .= '"'.$tmp[$x]['Name'].'" ';
    }
    $java_main->set_list($list);
    $java_main->set_option('"Set Heapsize" "set" "Change to '.$chg.'" "change" "Properties" "properties" "About" "about"');
    $ret = $java_main->exec();
    if ($ret[1] == 0)
      exit(0);
    $chose = $tmp[$ret[1]];
    switch ($ret[0])
    {
      case $ret[1];
      case "set";
        $reg_file = $chose['Directory']."/registry.txt";
        $reg = read_reg($reg_file);
        if ($reg != false)
        {
          $text->set_default($reg['heap']);
          $new_h = $text->exec();
          if ($new_h[1] == 0)
            break;
          if (ereg("^[0-9]+$", $new_h[0]))
          {
            exec("setconfig '$reg_file' 'Mot-JavaVM-Heapsize' '".$new_h[0]."'");
            $new_r = read_reg($reg_file);
            if ($new_r['heap'] == $new_h[0])
            {
              $success->set_context("Heapsize changed to ".$new_h[0]);
              $success->exec();
            }
            else
            {
              $error->set_context("Failed to change heapsize.");
              $error->exec();
            }
          }
          else
          {
            $error->set_context("Input number only!");
            $error->exec();
          }
        }
        break;
      case "change";
        if ($read == 0) $read = 1;
        else $read = 0;
        break;
      case "properties";
        $context = "Name: ".$chose['Name']."\nJava ID: ".$chose['JavaId']."\nDirectory: ".$chose['Directory']."\nSize: ".$chose['Size']."\n";
        $reg = read_reg($chose['Directory']."/registry.txt");
        if ($reg != false)
          $context .= "Domain: ".$reg['domain']."\nHeap Size: ".$reg['heap'];
        else
          $context .= "Error reading registry.";
        $properties->set_context($context);
        $properties->exec();
        break;
      case "about";
        $context = "JavaHS.php
(c) 2008 by Jeffri Hong

JavaHS is a program for change heapsize (or Mot-JavaVM-Heapsize) on each java registry files. This can make java run smoother and sometime solve 'Out of memory' problem. Go to our forum at MotoHell.com for more information of how to use this.

JavaHS is written in PHP and based on a script Javahs.lin written by some Chinese member. I'm sorry that I can't mention him because I don't know.

This program used show* binaries by Faruq, that was presented on Revival project.

Thank you.

Contact: keaglez@gmail.com
2008/8/3";
        $about->set_context($context);
        $about->exec();
        break;
    }
    unset($tmp);
  }
}


?>